## rocm-llvm 7.0.1+dfsg

=== amd/comgr/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.13.4)

include(CheckIncludeFileCXX)

file(READ "VERSION.txt" comgr_ver_file)

string(REGEX MATCH "#COMGR_VERSION_MAJOR\n([0-9]*)" _ ${comgr_ver_file})
set (ver_major ${CMAKE_MATCH_1})
string(REGEX MATCH "#COMGR_VERSION_MINOR\n([0-9]*)" _ ${comgr_ver_file})
set (ver_minor ${CMAKE_MATCH_1})

message("Comgr Version: ${ver_major}.${ver_minor}.0")

project(amd_comgr VERSION "${ver_major}.${ver_minor}.0" LANGUAGES C CXX)
set(amd_comgr_NAME "${PROJECT_NAME}")

# Get git branch and commit hash to add to log for easier debugging.
# Modeled after https://github.com/pmirshad/cmake-with-git-metadata.
# Current working branch
if(EXISTS "${CMAKE_SOURCE_DIR}/../../.git")
execute_process(
  COMMAND git rev-parse --abbrev-ref HEAD
  WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
  OUTPUT_VARIABLE AMD_COMGR_GIT_BRANCH
  OUTPUT_STRIP_TRAILING_WHITESPACE
)
# Shortened commit hash
execute_process(
  COMMAND git log -1 --format=%h
  WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
  OUTPUT_VARIABLE AMD_COMGR_GIT_COMMIT
  OUTPUT_STRIP_TRAILING_WHITESPACE
)
else(EXISTS "${CMAKE_SOURCE_DIR}/../../.git")
  set(AMD_COMGR_GIT_BRANCH "not-available")
  set(AMD_COMGR_GIT_COMMIT "not-available")
endif(EXISTS "${CMAKE_SOURCE_DIR}/../../.git")

include(GNUInstallDirs)
include(CMakePackageConfigHelpers)
option(FILE_REORG_BACKWARD_COMPATIBILITY "Enable File Reorg with backward compatibility" OFF)
# Optionally, build Compiler Support with ccache.
set(ROCM_CCACHE_BUILD OFF CACHE BOOL "Set to ON for a ccache enabled build")
if (ROCM_CCACHE_BUILD)
  find_program(CCACHE_PROGRAM ccache)
  if (CCACHE_PROGRAM)
    set_property(GLOBAL PROPERTY RULE_LAUNCH_COMPILE ${CCACHE_PROGRAM})
  else()
    message(WARNING "Unable to find ccache. Falling back to real compiler")
  endif() # if (CCACHE_PROGRAM)
endif() # if (ROCM_CCACHE_BUILD)

find_package(ROCM QUIET)
if (ROCM_FOUND)
  include(ROCMSetupVersion)
  rocm_setup_version(VERSION "${amd_comgr_VERSION}")
endif()

# BUILD_SHARED_LIBS is a frustratingly global variable common to all
# projects. LLVM also defines an option for the same varible with the
# opposite default, which will overwrite our default preference
# here. Ignore the regular BUILD_SHARED_LIBS in an embedded llvm
# build. Try to use BUILD_SHARED_LIBS to hint our project specific
# version in a standalone build.
set(build_shared_libs_default ON)
if(NOT DEFINED LLVM_SOURCE_DIR AND DEFINED BUILD_SHARED_LIBS)
  set(build_shared_libs_default ${BUILD_SHARED_LIBS})
endif()

option(COMGR_BUILD_SHARED_LIBS "Build the shared library"
       ${build_shared_libs_default})

set(SOURCES
  src/comgr-cache.cpp
  src/comgr-cache-command.cpp
  src/comgr-cache-bundler-command.cpp
  src/comgr-clang-command.cpp
  src/comgr-compiler.cpp
  src/comgr.cpp
  src/comgr-device-libs.cpp
  src/comgr-diagnostic-handler.cpp
  src/comgr-disassembly.cpp
  src/comgr-elfdump.cpp
  src/comgr-env.cpp
  src/comgr-metadata.cpp
  src/comgr-objdump.cpp
  src/comgr-signal.cpp
  src/comgr-spirv-command.cpp
  src/comgr-symbol.cpp
  src/comgr-symbolizer.cpp
  src/time-stat/time-stat.cpp)

if(COMGR_BUILD_SHARED_LIBS)
  add_library(amd_comgr SHARED ${SOURCES})
  # Windows doesn't have a strip utility, so CMAKE_STRIP won't be set.
  if((CMAKE_BUILD_TYPE STREQUAL "Release") AND NOT ("${CMAKE_STRIP}" STREQUAL ""))
    if (APPLE)
      # Building on Mac fails unless -x is passed to the strip command
      add_custom_command(TARGET amd_comgr POST_BUILD COMMAND ${CMAKE_STRIP} -x $<TARGET_FILE:amd_comgr>)
    else()
      add_custom_command(TARGET amd_comgr POST_BUILD COMMAND ${CMAKE_STRIP} $<TARGET_FILE:amd_comgr>)
    endif()
  endif()
else()
  add_library(amd_comgr STATIC ${SOURCES})
endif()

if(CMAKE_SOURCE_DIR STREQUAL CMAKE_CURRENT_SOURCE_DIR)
  find_package(AMDDeviceLibs REQUIRED CONFIG)
  find_package(Clang REQUIRED CONFIG)
  find_package(LLD REQUIRED CONFIG)

  target_include_directories(amd_comgr
    PRIVATE
      ${LLVM_INCLUDE_DIRS}
      ${CLANG_INCLUDE_DIRS}
      ${LLD_INCLUDE_DIRS})
else()
  # If building with LLVM_EXTERNAL_PROJECTS, we've already picked up
  # the include directories for LLVM, but not clang.
  #
  if (LLVM_EXTERNAL_CLANG_SOURCE_DIR)
    target_include_directories(amd_comgr
      PRIVATE
        ${LLVM_EXTERNAL_CLANG_SOURCE_DIR}/include
        ${LLVM_BINARY_DIR}/tools/clang/include)
  endif()

  if (LLVM_EXTERNAL_LLD_SOURCE_DIR)
    target_include_directories(amd_comgr
      PRIVATE
        ${LLVM_EXTERNAL_LLD_SOURCE_DIR}/include
        ${LLVM_BINARY_DIR}/tools/lld/include)
  endif()
endif()

target_include_directories(amd_comgr
  PRIVATE
  ${CMAKE_CURRENT_SOURCE_DIR}/src)

message("")
message("------------LLVM_DIR: ${LLVM_DIR}")
message("---LLVM_INCLUDE_DIRS: ${LLVM_INCLUDE_DIRS}")
message("---LLVM_LIBRARY_DIRS: ${LLVM_LIBRARY_DIRS}")
message("-----------Clang_DIR: ${Clang_DIR}")
message("--CLANG_INCLUDE_DIRS: ${CLANG_INCLUDE_DIRS}")
message("----LLD_INCLUDE_DIRS: ${LLD_INCLUDE_DIRS}")
message("---AMDDeviceLibs_DIR: ${AMDDeviceLibs_DIR}")
message("------------ROCM_DIR: ${ROCM_DIR}")

list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake")

if (ADDRESS_SANITIZER)
  set(ASAN_LINKER_FLAGS "-fsanitize=address")
  set(ASAN_COMPILER_FLAGS "-fno-omit-frame-pointer -fsanitize=address")

  if (NOT CMAKE_COMPILER_IS_GNUCC)
    if (COMGR_BUILD_SHARED_LIBS)
      set(ASAN_LINKER_FLAGS "${ASAN_LINKER_FLAGS} -shared-libsan")
    else()
      set(ASAN_LINKER_FLAGS "${ASAN_LINKER_FLAGS} -static-libsan")
    endif()
  endif()

  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${ASAN_COMPILER_FLAGS}")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${ASAN_COMPILER_FLAGS}")
  set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} ${ASAN_LINKER_FLAGS} -s")
  set(CMAKE_SHARED_LINKER_FLAGS
    "${CMAKE_SHARED_LINKER_FLAGS} ${ASAN_LINKER_FLAGS}")
endif()

set(AMD_COMGR_PRIVATE_COMPILE_OPTIONS)
set(AMD_COMGR_PRIVATE_COMPILE_DEFINITIONS ${LLVM_DEFINITIONS})
set(AMD_COMGR_PUBLIC_LINKER_OPTIONS)
set(AMD_COMGR_PRIVATE_LINKER_OPTIONS)

list(APPEND AMD_COMGR_PRIVATE_COMPILE_DEFINITIONS "AMD_COMGR_GIT_COMMIT=${AMD_COMGR_GIT_COMMIT}")
list(APPEND AMD_COMGR_PRIVATE_COMPILE_DEFINITIONS "AMD_COMGR_GIT_BRANCH=${AMD_COMGR_GIT_BRANCH}")
message("----COMGR_GIT_COMMIT: ${AMD_COMGR_GIT_COMMIT}")
message("----COMGR_GIT_BRANCH: ${AMD_COMGR_GIT_BRANCH}")
message("")

option(COMGR_DISABLE_SPIRV "To disable SPIRV in Comgr" OFF)

if (NOT COMGR_DISABLE_SPIRV)
  # TODO: Explore switching this to CHECK_INCLUDE_FILE_CXX() macro
  if (NOT EXISTS "${LLVM_INCLUDE_DIRS}/LLVMSPIRVLib/LLVMSPIRVLib.h")
    message("-- LLVMSPIRVLib/LLVMSPIRVLib.h not found")
    set(COMGR_DISABLE_SPIRV ON)
  else()
    message("-- LLVMSPIRVLib/LLVMSPIRVLib.h found")
  endif()
endif()

if(${COMGR_DISABLE_SPIRV})
    list(APPEND AMD_COMGR_PRIVATE_COMPILE_DEFINITIONS "COMGR_DISABLE_SPIRV")
  message("-- Comgr SPIRV Disabled")
else()
  message("-- Comgr SPIRV Enabled")
endif()


if (UNIX)
  list(APPEND AMD_COMGR_PRIVATE_COMPILE_OPTIONS
    -fno-rtti -Wall -Wno-attributes -fms-extensions -fvisibility=hidden)
  # TODO: Confirm this is actually needed due to LLVM/Clang code
  list(APPEND AMD_COMGR_PRIVATE_COMPILE_OPTIONS -fno-strict-aliasing)
  list(APPEND AMD_COMGR_PRIVATE_COMPILE_DEFINITIONS
    _GNU_SOURCE __STDC_LIMIT_MACROS __STDC_CONSTANT_MACROS AMD_COMGR_BUILD)
  list(APPEND AMD_COMGR_PUBLIC_LINKER_OPTIONS -pthread)
  if (NOT APPLE AND COMGR_BUILD_SHARED_LIBS)
    configure_file(
      src/exportmap.in
      src/exportmap @ONLY)
    list(APPEND AMD_COMGR_PRIVATE_LINKER_OPTIONS
      "-Wl,--version-script=${CMAKE_CURRENT_BINARY_DIR}/src/exportmap")
    # When building a shared library with -fsanitize=address we can't be
    # strict about undefined symbol references, as Clang won't include
    # libasan in the link, see
    # https://clang.llvm.org/docs/AddressSanitizer.html
    if (NOT ADDRESS_SANITIZER)
      list(APPEND AMD_COMGR_PRIVATE_LINKER_OPTIONS
        -Wl,--no-undefined)
    endif()
  endif()
elseif (CMAKE_CXX_COMPILER_ID STREQUAL "MSVC")
  list(APPEND AMD_COMGR_PRIVATE_COMPILE_OPTIONS
    "/wd4244" #[[Suppress 'argument' : conversion from 'type1' to 'type2', possible loss of data]]
    "/wd4624" #[[Suppress 'derived class' : destructor could not be generated because a base class destructor is inaccessible]]
    "/wd4267" #[[Suppress 'var' : conversion from 'size_t' to 'type', possible loss of data]]
    "/wd4291" #[[Suppress 'declaration' : no matching operator delete found; memory will not be freed if initialization throws an exception]]
    "/wd4146" #[[Suppress 'unary minus operator applied to unsigned type, result still unsigned]])
  list(APPEND AMD_COMGR_PRIVATE_COMPILE_DEFINITIONS _HAS_EXCEPTIONS=0)
endif()

# Windows is strict about visibility of exports in shared libraries, so we ask
# GCC/Clang to also be strict, and then explicitly mark each exported symbol in
# the shared header.
list(APPEND AMD_COMGR_PRIVATE_COMPILE_DEFINITIONS AMD_COMGR_EXPORT)

include(bc2h)
include(opencl_pch)
include(DeviceLibs)

# Add major version to the name on windows, including Win64
if (WIN32)
  set_target_properties(amd_comgr PROPERTIES
    OUTPUT_NAME "amd_comgr_${amd_comgr_VERSION_MAJOR}")
endif()

set_target_properties(amd_comgr PROPERTIES
  CXX_STANDARD 17
  CXX_STANDARD_REQUIRED Yes
  CXX_EXTENSIONS No)
if (ROCM_FOUND)
  rocm_set_soversion(amd_comgr "${amd_comgr_VERSION_MAJOR}.${amd_comgr_VERSION_MINOR}")
else()
  set_target_properties(amd_comgr PROPERTIES
    SOVERSION "${amd_comgr_VERSION_MAJOR}"
    VERSION "${amd_comgr_VERSION_MAJOR}.${amd_comgr_VERSION_MINOR}.${amd_comgr_VERSION_PATCH}")
endif()

if (NOT COMGR_BUILD_SHARED_LIBS)
  set_target_properties(amd_comgr PROPERTIES POSITION_INDEPENDENT_CODE ON)
endif()

# Overwrite the name on 32-bit Linux and Windows
if (CMAKE_SIZEOF_VOID_P EQUAL 4)
  set_target_properties(amd_comgr PROPERTIES OUTPUT_NAME "amd_comgr32")
endif()

target_compile_options(amd_comgr
  PRIVATE "${AMD_COMGR_PRIVATE_COMPILE_OPTIONS}")
target_compile_definitions(amd_comgr
  PRIVATE "${AMD_COMGR_PRIVATE_COMPILE_DEFINITIONS}")
target_include_directories(amd_comgr
  PUBLIC
    $<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}/include>
    $<INSTALL_INTERFACE:include>)

configure_file(
  include/amd_comgr.h.in
  include/amd_comgr.h @ONLY)

set(AMD_COMGR_CONFIG_NAME amd_comgr-config.cmake)
set(AMD_COMGR_TARGETS_NAME amd_comgr-targets.cmake)
set(AMD_COMGR_VERSION_NAME amd_comgr-config-version.cmake)
set(AMD_COMGR_PACKAGE_PREFIX cmake/amd_comgr)

# Generate the build-tree package.
set(AMD_COMGR_PREFIX_CODE)
if (NOT COMGR_BUILD_SHARED_LIBS)
  string(APPEND AMD_COMGR_PREFIX_CODE "\ninclude(CMakeFindDependencyMacro)\n")
  string(APPEND AMD_COMGR_PREFIX_CODE "find_dependency(Clang REQUIRED)\n")
  string(APPEND AMD_COMGR_PREFIX_CODE "find_dependency(LLD REQUIRED)\n")
endif()

set(AMD_COMGR_TARGETS_PATH
  "${CMAKE_CURRENT_BINARY_DIR}/lib/${AMD_COMGR_PACKAGE_PREFIX}/${AMD_COMGR_TARGETS_NAME}")
set(AMD_COMGR_VERSION_PATH
  "${CMAKE_CURRENT_BINARY_DIR}/lib/${AMD_COMGR_PACKAGE_PREFIX}/${AMD_COMGR_VERSION_NAME}")
export(TARGETS amd_comgr
  FILE "lib/${AMD_COMGR_PACKAGE_PREFIX}/${AMD_COMGR_TARGETS_NAME}")
configure_file("cmake/${AMD_COMGR_CONFIG_NAME}.in"
  "lib/${AMD_COMGR_PACKAGE_PREFIX}/${AMD_COMGR_CONFIG_NAME}"
  @ONLY)
write_basic_package_version_file("${AMD_COMGR_VERSION_PATH}"
  VERSION "${amd_comgr_VERSION}"
  COMPATIBILITY SameMajorVersion)

if(ENABLE_ASAN_PACKAGING)
  install(TARGETS amd_comgr
    EXPORT amd_comgr_export
    COMPONENT asan
    LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR})
else()
  install(TARGETS amd_comgr
    EXPORT amd_comgr_export
    COMPONENT amd-comgr
    RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
    LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
    ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR})
endif()

install(FILES
  "${CMAKE_CURRENT_BINARY_DIR}/include/amd_comgr.h"
  COMPONENT amd-comgr
  DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/${amd_comgr_NAME})

#File reorg Backward compatibility function
if(FILE_REORG_BACKWARD_COMPATIBILITY)

=== amd/comgr/test-lit/CMakeLists.txt ===
function(cannonicalize_cmake_boolean var)
    if(${var})
        set(${var} 1 PARENT_SCOPE)
    else()
        set(${var} 0 PARENT_SCOPE)
    endif()
endfunction()

cannonicalize_cmake_boolean(COMGR_DISABLE_SPIRV)

configure_file(lit.site.cfg.py.in lit.site.cfg.py @ONLY)

if (NOT DEFINED LLVM_LIT_PATH)
  # Comgr source build
  if (EXISTS "${LLVM_TOOLS_BINARY_DIR}/../../bin/llvm-lit")
    set(LLVM_LIT_PATH "${LLVM_TOOLS_BINARY_DIR}/../../bin/llvm-lit")
  # LLVM external projects build
  else()
    set(LLVM_LIT_PATH "${LLVM_TOOLS_BINARY_DIR}/llvm-lit")
  endif()
endif()
message("--LLVM_LIT_PATH: ${LLVM_LIT_PATH}")

add_custom_target(test-lit COMMAND "${LLVM_LIT_PATH}"
                  "${CMAKE_CURRENT_BINARY_DIR}" -v)

macro(add_comgr_lit_binary name)
  add_executable("${name}" "comgr-sources/${name}.c")
  set_target_properties("${name}" PROPERTIES
    C_STANDARD 99
    C_STANDARD_REQUIRED Yes
    C_EXTENSIONS No)
  target_link_libraries("${name}" amd_comgr)
  add_dependencies(check-comgr "${name}")
endmacro()

set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR})

add_comgr_lit_binary(source-to-bc-with-dev-libs)
add_comgr_lit_binary(spirv-translator)
add_comgr_lit_binary(compile-minimal-test)
add_comgr_lit_binary(spirv-to-reloc)

add_dependencies(check-comgr test-lit)

=== amd/device-libs/ockl/CMakeLists.txt ===
##===--------------------------------------------------------------------------
##                   ROCm Device Libraries
##
## This file is distributed under the University of Illinois Open Source
## License. See LICENSE.TXT for details.
##===--------------------------------------------------------------------------

file(GLOB sources
  ${CMAKE_CURRENT_SOURCE_DIR}/src/*.cl
  ${CMAKE_CURRENT_SOURCE_DIR}/src/*.ll
)

include_directories(${CMAKE_CURRENT_SOURCE_DIR}/../irif/inc)
include_directories(${CMAKE_CURRENT_SOURCE_DIR}/../oclc/inc)
include_directories(${CMAKE_CURRENT_SOURCE_DIR}/inc)

set_source_files_properties(
  ${CMAKE_CURRENT_SOURCE_DIR}/src/gaaf.cl
  PROPERTIES COMPILE_FLAGS "-munsafe-fp-atomics")

opencl_bc_lib(NAME ockl SOURCES ${sources})

=== amd/device-libs/oclc/CMakeLists.txt ===
##===--------------------------------------------------------------------------
##                   ROCm Device Libraries
##
## This file is distributed under the University of Illinois Open Source
## License. See LICENSE.TXT for details.
##===--------------------------------------------------------------------------

file(GLOB sources
  ${CMAKE_CURRENT_SOURCE_DIR}/src/*.cl
)

include_directories(${CMAKE_CURRENT_SOURCE_DIR}/inc)

foreach (file ${sources})
  get_filename_component(dir ${file} DIRECTORY)
  get_filename_component(name ${file} NAME_WE)
  get_filename_component(ext ${file} EXT)
  opencl_bc_lib(NAME oclc_${name} SOURCES ${file})
endforeach()

=== amd/device-libs/ocml/CMakeLists.txt ===
##===--------------------------------------------------------------------------
##                   ROCm Device Libraries
##
## This file is distributed under the University of Illinois Open Source
## License. See LICENSE.TXT for details.
##===--------------------------------------------------------------------------

file(GLOB sources
  ${CMAKE_CURRENT_SOURCE_DIR}/src/*.cl
  )

include_directories(${CMAKE_CURRENT_SOURCE_DIR}/../irif/inc)
include_directories(${CMAKE_CURRENT_SOURCE_DIR}/../oclc/inc)
include_directories(${CMAKE_CURRENT_SOURCE_DIR}/inc)
include_directories(${CMAKE_CURRENT_SOURCE_DIR}/src)

set(native_func_flags -fapprox-func)

set_source_files_properties(
  ${CMAKE_CURRENT_SOURCE_DIR}/src/native_logF.cl
  ${CMAKE_CURRENT_SOURCE_DIR}/src/native_expF.cl
  PROPERTIES COMPILE_FLAGS "${native_func_flags}")

opencl_bc_lib(NAME ocml SOURCES ${sources})

=== debian/changelog ===
rocm-llvm (7.0.1+dfsg-1~exp1) experimental; urgency=medium

  * New upstream version 7.0.1+dfsg
  * Update copyright file
    * Fix comgr license text. The NCSA license used for comgr
      prohibits using the name of Advanced Micro Devices, Inc.,
      for endorsements, but this was not previously reflected
      in the copyright file.
  * Update from LLVM 20 to LLVM 21
    * Drop rocm-device-libs-20 and add rocm-device-libs-21
    * Add compatibility patches for comgr backported from upstream
      commits, as the rocm-llvm upstream is based on LLVM 20:
      * d/p/comgr-fix-createAsmStreamer.patch
      * d/p/fix-DiagnosticOptions-IntrusiveRefCntPtr.patch
  * Replace perl hipconfig and hipcc scripts with precompiled
    executables, as the perl versions have been removed upstream.
    * Move hipcc from libdevel section to devel section.
    * Replace hipconfig with symbolic link to hipcc. The name of
      the command is used to choose the operation performed.
    * Drop perl script patches:
      * d/p/specify-compiler-version-and-option.patch
      * d/p/add-hipvars-to-perl-include-path.patch
      * d/p/fix-HIP_version.patch
      * d/p/use-Debian-FHS-to-find-runtime-components.patch
    * Add d/p/specify-clang-version.patch to direct hipcc to use
      LLVM 21.
    * Add d/p/fix-devicelibs-path.patch to ensure hipcc does not
      pass clang a non-existant path to the ROCm device libs. This
      ensures that clang will search in the system default locations
      for the device libraries.
    * Add fix-hip-clang-path.patch to ensure that hipcc considers
      /usr/bin when searching for clang.
  * d/rules: fix path to AMDDeviceLibs on non-x86 systems
  * d/copyright: update my email address
  * Update standards version to 4.7.2. No changes required.

 -- Cordell Bloor <cgmb@debian.org>  Sun, 28 Sep 2025 02:38:25 -0600

=== debian/control ===
Source: rocm-llvm
Section: devel
Priority: optional
Maintainer: Debian ROCm Team <debian-ai@lists.debian.org>
Uploaders: Xuanteng Huang <xuanteng.huang@outlook.com>,
           Christian Kastner <ckk@debian.org>,
           Cordell Bloor <cgmb@debian.org>
Standards-Version: 4.7.2
Homepage: https://github.com/ROCm/llvm-project
Vcs-Browser: https://salsa.debian.org/rocm-team/rocm-llvm
Vcs-Git: https://salsa.debian.org/rocm-team/rocm-llvm.git
Build-Depends: debhelper-compat (= 13),
               cmake,
               clang-21,
               clang-tools-21,
               libclang-21-dev,
               libclang-rt-21-dev,
               libhsa-runtime-dev (>= 6.1.2~),
               libnuma-dev,
               lld-21,
               liblld-21-dev,
               llvm-21-dev,
               libzstd-dev,
               zlib1g-dev,
               libxml2-dev,
               chrpath,
Rules-Requires-Root: no

Package: hipcc
Section: devel
Architecture: amd64 arm64 ppc64el
Depends: ${misc:Depends},
         ${shlibs:Depends},
         clang-21,
         llvm-21,
         lld-21,
         clang-tools-21,
         libclang-rt-21-dev,
         rocm-device-libs-21 (= ${binary:Version}),
         rocminfo (>= 6.1.2~),
         libamdhip64-dev
Description: C++ Runtime API and Kernel Language for AMD and NVIDIA GPUs
 HIP (Heterogeneous Interface for Portability) is a C++ Runtime API and Kernel
 Language that allows developers to create portable applications for AMD and
 NVIDIA GPUs from single source code.
 .
 Key features include:
 .
  * HIP is very thin and has little or no performance impact over coding
    directly in CUDA mode;
  * HIP allows coding in a single-source C++ programming language including
    features such as templates, C++11 lambdas, classes, namespaces, and more;
  * HIP allows developers to use the "best" development environment and tools
    on each target platform;
  * the HIPify tools automatically convert source from CUDA to HIP;
  * developers can specialize for the platform (CUDA or AMD) to tune for
    performance or handle tricky cases.
 .
 New projects can be developed directly in the portable HIP C++ language and
 can run on either NVIDIA or AMD platforms.  Additionally, HIP provides porting
 tools which make it easy to port existing CUDA codes to the HIP layer, with no
 loss of performance as compared to the original CUDA application.  HIP is not
 intended to be a drop-in replacement for CUDA, and developers should expect to
 do some manual coding and performance tuning work to complete the port.
 .
 This package provides the compiler to compile the HIP source programs.

Package: rocm-device-libs-21
Architecture: any
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends},
Description: AMD specific device-side language runtime libraries
 Set of AMD specific device-side language runtime libraries, specifically: the
 Open Compute library controls, the Open Compute Math library, the Open Compute
 Kernel library, the OpenCL built-in library, the HIP built-in library, and the
 Heterogeneous Compute built-in library.

Package: libamd-comgr3
Architecture: any
Section: libs
Depends: ${misc:Depends},
         ${shlibs:Depends},
Multi-Arch: same
Description: ROCm code object manager
 The Code Object Manager is a shared library which provides operations for
 creating and inspecting LLVM code objects. See the documentation in the
 header file /usr/include/amd_comgr/amd_comgr.h .

Package: libamd-comgr-dev
Architecture: any
Section: libdevel
Depends: libamd-comgr3 (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Description: ROCm code object manager - development package
 The Code Object Manager is a shared library which provides operations for
 creating and inspecting LLVM code objects. See the documentation in the
 header file /usr/include/amd_comgr/amd_comgr.h .
 .
 This package contains the development files.

=== debian/rules ===
#!/usr/bin/make -f
include /usr/share/dpkg/pkg-info.mk

export DH_VERBOSE = 1
export DEB_BUILD_MAINT_OPTIONS = hardening=+all optimize=-lto
export DEB_CXXFLAGS_MAINT_PREPEND = -gz

CFLAGS := $(subst -fno-cf-protection,,$(CXXFLAGS))
CXXFLAGS := $(subst -fno-cf-protection,,$(CXXFLAGS))

ifneq ($(filter $(DEB_HOST_ARCH),armel mipsel powerpc),)
DEVICE_LIBS_CONFIG_FLAGS += -DCMAKE_CXX_STANDARD_LIBRARIES=-latomic
endif

%:
	dh $@

# comgr and hipcc rely on device-libs, so we have to build it first before config these 2 packages
override_dh_auto_configure:
	dh_auto_configure --buildsystem=cmake --sourcedir=amd/device-libs --builddir=build.device-libs \
				-- $(DEVICE_LIBS_CONFIG_FLAGS)
	dh_auto_build --builddir=build.device-libs

	dh_auto_configure --buildsystem=cmake --sourcedir=amd/comgr --builddir=build.comgr \
				-- -DCMAKE_PREFIX_PATH="/usr/lib/llvm-21" \
				-DAMDDeviceLibs_DIR="$(CURDIR)/build.device-libs/lib/$(DEB_HOST_MULTIARCH)/cmake/AMDDeviceLibs" \
				-DBUILD_TESTING=OFF -DCOMGR_BUILD_SHARED_LIBS=ON \
				-DBUILD_FILE_REORG_BACKWARD_COMPATIBILITY=OFF

	dh_auto_configure --buildsystem=cmake --sourcedir=amd/hipcc --builddir=build.hipcc \
				-- -DHIPCC_BACKWARD_COMPATIBILITY=ON

override_dh_auto_build:
	dh_auto_build --builddir=build.comgr
	dh_auto_build --builddir=build.hipcc

# dwz doesn't fully support DWARF-5 yet, see #1016936
override_dh_dwz:
	:

override_dh_auto_install:
	dh_auto_install -O--buildsystem=cmake -O--builddirectory=$(CURDIR)/build.device-libs
	dh_auto_install -O--buildsystem=cmake -O--builddirectory=$(CURDIR)/build.comgr
	dh_auto_install -O--buildsystem=cmake -O--builddirectory=$(CURDIR)/build.hipcc

override_dh_install:
	mv $(CURDIR)/build.comgr/amd_comgr-config.cmake.install $(CURDIR)/build.comgr/amd_comgr-config.cmake
	chrpath -d $(shell find . -type f -name libamd_comgr.so*)
	dh_install

override_dh_shlibdeps:
	dh_shlibdeps --dpkg-shlibdeps-params=--ignore-missing-info

=== debian/tests/control ===
Tests: hipcc.sh,
       clang.sh,
       hipconfig.sh,
       gcc.sh,
       g++.sh,
Depends: hipcc (>= 6.1.2~), cmake, make, gcc, g++, rocminfo (>= 6.1.2~), libamdhip64-dev (>= 5.7.1)
Restrictions: superficial, skippable

## rocm-llvm 7.0.2%2Bdfsg

=== amd/comgr/test/CMakeLists.txt ===
set(TEST_INPUT_BINARIES)
set(TEST_INPUT_BITCODES)
set(TEST_INPUT_BUNDLES)
set(TEST_INPUT_ARCHIVES)
set(TEST_INPUT_LINKED_OBJS)

# Create target ${name} which depends on a clang command to compile ${input} to
# ${output}, with any additional arguments from ${ARGN}, and add it to the
# TEST_INPUT_BINARIES target list.
macro(add_test_input_binary name input output)
  add_custom_command(
    OUTPUT "${output}"
    COMMAND "$<TARGET_FILE:clang>" --target=amdgcn-amd-amdhsa -mcpu=gfx900 -nogpulib
    ${ARGN} "${CMAKE_CURRENT_SOURCE_DIR}/${input}" -o "${output}"
    VERBATIM
    DEPENDS clang lld "${input}")
  add_custom_target("${name}"
    DEPENDS "${output}"
    SOURCES "${input}")
  list(APPEND TEST_INPUT_BINARIES "${name}")
endmacro()

# Creates target ${name} which depends on a clang command to compile ${input} to
# ${output}, with any additional arguments from ${ARGN}, and add it to the
# TEST_INPUT_BITCODES target list.
macro(add_test_input_bitcode name input output)
  add_custom_command(
    OUTPUT "${output}"
    COMMAND "$<TARGET_FILE:clang>" -c -emit-llvm -target amdgcn-amd-amdhsa
    -mcpu=gfx900 -nogpulib
    ${ARGN} "${CMAKE_CURRENT_SOURCE_DIR}/${input}"
    -o "${output}"
    VERBATIM
    DEPENDS clang lld "${input}")
  add_custom_target("${name}"
    DEPENDS "${output}"
    SOURCES "${input}")
  list(APPEND TEST_INPUT_BITCODES "${name}")
endmacro()

# Creates target ${name} which depends on a clang command to compile ${input} to
# ${output}, with any additional arguments from ${ARGN}, and add it to the
# TEST_INPUT_BUNDLES target list.
macro(add_test_input_bitcode_bundle name input output)
  add_custom_command(
    OUTPUT "${output}"
    COMMAND "$<TARGET_FILE:clang>" -c --offload-arch=gfx900 -emit-llvm -fgpu-rdc
    --gpu-bundle-output ${ARGN} "${CMAKE_CURRENT_SOURCE_DIR}/${input}" -nogpulib
    -o "${output}"
    VERBATIM
    DEPENDS clang lld "${input}")
  add_custom_target("${name}"
    DEPENDS "${output}"
    SOURCES "${input}")
  list(APPEND TEST_INPUT_BUNDLES "${name}")
endmacro()

# Creates target ${name} which depends on a clang command to compile ${input} to
# ${output}, with any additional arguments from ${ARGN}, and add it to the
# TEST_INPUT_BUNDLES target list.
macro(add_test_input_object_file_bundle name input output)
  add_custom_command(
    OUTPUT "${output}"
    COMMAND "$<TARGET_FILE:clang>" -c --offload-arch=gfx900 --gpu-bundle-output
    --offload-device-only ${ARGN} "${CMAKE_CURRENT_SOURCE_DIR}/${input}" -nogpulib
    -o "${output}"
    VERBATIM
    DEPENDS clang lld "${input}")
  add_custom_target("${name}"
    DEPENDS "${output}"
    SOURCES "${input}")
  list(APPEND TEST_INPUT_BUNDLES "${name}")
endmacro()

# Creates target ${name} and output ${output} by archiving a file.
# ${target} should refer to the a target created in the above
# add_test_input_bitcode() macro, and ${input} should refer
# to the associated bitcode file built by the same macro.
macro(add_test_archive name target input output)
  add_custom_command(
    OUTPUT "${output}"
    COMMAND "$<TARGET_FILE:llvm-ar>" rc "${output}" "${input}"
    VERBATIM
    DEPENDS clang lld ${target})
  add_custom_target("${name}"
    DEPENDS "${output}"
    SOURCES "${input}")
  list(APPEND TEST_INPUT_ARCHIVES "${name}")
endmacro()

# Creates target ${name} which depends on 2 clang commands to compile
# ${input0} and ${input1} and then links them to create ${output}
#  with any additional arguments from ${ARGN}, and add it to the
# TEST_INPUT_LINKED_OBJS target list.
macro(add_test_input_linked name input0 input1 output)
  add_custom_command(
    OUTPUT "${output}"
    COMMAND "$<TARGET_FILE:lld>" -flavor gnu ${ARGN} "${input0}"
    "${input1}" -o "${output}"
    VERBATIM
    DEPENDS lld "${input0}" "${input1}")
  add_custom_target("${name}"
    DEPENDS "${output}"
    SOURCES "${input0}" "${input1}")
  list(APPEND TEST_INPUT_LINKED_OBJS "${name}")
endmacro()

add_test_input_binary(reloc1 source/reloc1.cl source/reloc1.o -c -mcode-object-version=4)
add_test_input_binary(reloc2 source/reloc2.cl source/reloc2.o -c -mcode-object-version=4)
add_test_input_binary(reloc-asm source/reloc-asm.s source/reloc-asm.o -c -mcode-object-version=4)
add_test_input_binary(shared source/shared.cl source/shared.so -mcode-object-version=4)
add_test_input_binary(symbolize-debug source/symbolize.cl source/symbolize-debug.so -c -g -O3 -mcode-object-version=4)
add_test_input_bitcode(source1 source/source1.cl source/source1.bc)

add_test_input_binary(linking-kernel0 source/linking/kernel0.cl source/linking/kernel0.o -c -mcode-object-version=4)
add_test_input_binary(linking-kernel1 source/linking/kernel1.cl source/linking/kernel1.o -c -mcode-object-version=4)
add_test_input_binary(linking-empty   source/linking/empty.cl   source/linking/empty.o   -c -mcode-object-version=4)

add_test_input_linked(multiple-note-records source/linking/kernel0.o source/linking/kernel1.o source/multiple-note-records.out -w)
add_test_input_linked(multiple-note-records-one-kernel source/linking/kernel0.o source/linking/empty.o source/multiple-note-records-one-kernel.out -w)

add_test_input_bitcode_bundle(square source/square.hip source/square.bc)
add_test_input_object_file_bundle(double source/double.hip source/double.o)

add_test_input_bitcode_bundle(cube source/cube.hip source/cube.bc)
add_test_archive(cube_archive cube source/cube.bc source/cube.a)

configure_file("source/linking/kernel0.cl" "source/linking/kernel0.cl" COPYONLY)
configure_file("source/linking/kernel1.cl" "source/linking/kernel1.cl" COPYONLY)
configure_file("source/linking/empty.cl" "source/linking/empty.cl" COPYONLY)
configure_file("source/source1.cl" "source/source1.cl" COPYONLY)
configure_file("source/source2.cl" "source/source2.cl" COPYONLY)
configure_file("source/nested-kernel1.cl" "source/nested-kernel1.cl" COPYONLY)
configure_file("source/nested-kernel2.cl" "source/nested-kernel2.cl" COPYONLY)
configure_file("source/shared.cl" "source/shared.cl" COPYONLY)
configure_file("source/symbolize.cl" "source/symbolize.cl" COPYONLY)
configure_file("source/device_libs.cl" "source/device_libs.cl" COPYONLY)
configure_file("source/include-macro.h" "source/include-macro.h" COPYONLY)
configure_file("source/include-nested.h" "source/include-nested.h" COPYONLY)
configure_file("source/source1.s" "source/source1.s" COPYONLY)
configure_file("source/source1.hip" "source/source1.hip" COPYONLY)
configure_file("source/name-expression.hip" "source/name-expression.hip" COPYONLY)
configure_file("source/rocm56slice.b" "source/rocm56slice.b" COPYONLY)
configure_file("source/rocm57slice.b" "source/rocm57slice.b" COPYONLY)

configure_file("source/square.hip" "source/square.hip" COPYONLY)
configure_file("source/double.hip" "source/double.hip" COPYONLY)
configure_file("source/cube.hip" "source/cube.hip" COPYONLY)

# We no longer support emission of code object v2/v3. The runtime however
# can still load them so we need to test them using prebuilt binaries.
configure_file("source/legacy/shared-v2.so" "source/shared-v2.so" COPYONLY)
configure_file("source/legacy/shared12-v2.so" "source/shared12-v2.so" COPYONLY)
configure_file("source/legacy/shared14-v2.so" "source/shared14-v2.so" COPYONLY)
configure_file("source/legacy/shared23-v2.so" "source/shared23-v2.so" COPYONLY)
configure_file("source/legacy/source1-v2.o" "source/source1-v2.o" COPYONLY)
configure_file("source/legacy/source2-v2.o" "source/source2-v2.o" COPYONLY)
configure_file("source/legacy/source3-v2.o" "source/source3-v2.o" COPYONLY)
configure_file("source/legacy/source4-v2.o" "source/source4-v2.o" COPYONLY)

configure_file("source/legacy/shared-v3.so" "source/shared-v3.so" COPYONLY)
configure_file("source/legacy/shared12-v3.so" "source/shared12-v3.so" COPYONLY)
configure_file("source/legacy/shared14-v3.so" "source/shared14-v3.so" COPYONLY)
configure_file("source/legacy/shared23-v3.so" "source/shared23-v3.so" COPYONLY)
configure_file("source/legacy/source1-v3.o" "source/source1-v3.o" COPYONLY)
configure_file("source/legacy/source2-v3.o" "source/source2-v3.o" COPYONLY)
configure_file("source/legacy/source3-v3.o" "source/source3-v3.o" COPYONLY)
configure_file("source/legacy/source4-v3.o" "source/source4-v3.o" COPYONLY)

# Creates executable ${name} and accompanying test ${name} built from
# test/${name}.cl
macro(add_comgr_test name lang)
  set(test_name "comgr_${name}")
  add_executable("${name}" "${name}.${lang}")
  set_target_properties("${name}" PROPERTIES
    C_STANDARD 99
    C_STANDARD_REQUIRED Yes
    C_EXTENSIONS No)
  target_compile_definitions("${name}"
    PRIVATE -DTEST_OBJ_DIR=\"${CMAKE_CURRENT_BINARY_DIR}/source\")
if (CMAKE_CXX_COMPILER_ID STREQUAL "MSVC")
  target_compile_definitions("${name}"
    PRIVATE -D_CRT_SECURE_NO_WARNINGS)
endif()

  target_link_libraries("${name}"
    amd_comgr)
  add_dependencies("${name}"
    ${TEST_INPUT_BINARIES};${TEST_INPUT_BITCODES};${TEST_INPUT_BUNDLES};
    ${TEST_INPUT_ARCHIVES};${TEST_INPUT_LINKED_OBJS})
  add_test(NAME ${test_name}
    COMMAND "${name}")
  add_dependencies(check-comgr ${name})
  # Windows binaries have no equivalent to RPATH, so we must set their PATH to
  # include the .lib/.dll directory.
  if (UNIX)
    set_tests_properties(${test_name}
      PROPERTIES ENVIRONMENT "AMD_COMGR_CACHE=0;")
  else()
    set_tests_properties(${test_name}
      PROPERTIES ENVIRONMENT "PATH=$<TARGET_LINKER_FILE_DIR:amd_comgr>;AMD_COMGR_CACHE=0;")
  endif()
endmacro()

find_package(hip CONFIG PATHS ${ROCM_INSTALL_PATH}/hip QUIET)

add_comgr_test(data_test c)
add_comgr_test(disasm_llvm_reloc_test c)
add_comgr_test(disasm_llvm_so_test c)
add_comgr_test(disasm_instr_test c)
add_comgr_test(disasm_options_test c)
add_comgr_test(metadata_tp_test c)
add_comgr_test(metadata_yaml_test c)
add_comgr_test(metadata_msgpack_test c)
add_comgr_test(metadata_multiple_msgpacks_test c)
add_comgr_test(metadata_merge_test c)
add_comgr_test(symbols_test c)
add_comgr_test(symbols_iterate_test c)
add_comgr_test(compile_test c)
add_comgr_test(compile_minimal_test c)
add_comgr_test(compile_log_test c)
add_comgr_test(compile_log_remarks_test c)
add_comgr_test(compile_source_with_device_libs_to_bc_test c)
add_comgr_test(compile_source_with_device_libs_to_bc_with_vfs_test c)
add_comgr_test(assemble_test c)
add_comgr_test(link_test c)
add_comgr_test(isa_name_parsing_test c)
add_comgr_test(get_data_isa_name_test c)
add_comgr_test(include_subdirectory_test c)
add_comgr_test(options_test c)
add_comgr_test(demangle_test c)
add_comgr_test(fail_to_build_driver c)
add_comgr_test(file_map c)
add_comgr_test(lookup_code_object_test c)
add_comgr_test(symbolize_test c)
add_comgr_test(mangled_names_test c)
add_comgr_test(multithread_test cpp)
add_comgr_test(nested_kernel_test c)
add_comgr_test(map_elf_virtual_address_test c)
add_comgr_test(compile_source_to_executable c)
add_comgr_test(name_expression_map_test c)
add_comgr_test(compile_hip_test c)
add_comgr_test(compile_hip_to_relocatable c)
add_comgr_test(mangled_names_hip_test c)
add_comgr_test(unbundle_hip_test c)

=== amd/device-libs/opencl/CMakeLists.txt ===
##===--------------------------------------------------------------------------
##                   ROCm Device Libraries
##
## This file is distributed under the University of Illinois Open Source
## License. See LICENSE.TXT for details.
##===--------------------------------------------------------------------------

file(GLOB cl_sources
  ${CMAKE_CURRENT_SOURCE_DIR}/src/async/*.cl
  ${CMAKE_CURRENT_SOURCE_DIR}/src/common/*.cl
  ${CMAKE_CURRENT_SOURCE_DIR}/src/devenq/*.cl
  ${CMAKE_CURRENT_SOURCE_DIR}/src/geometric/*.cl
  ${CMAKE_CURRENT_SOURCE_DIR}/src/image/*.cl
  ${CMAKE_CURRENT_SOURCE_DIR}/src/integer/*.cl
  ${CMAKE_CURRENT_SOURCE_DIR}/src/math/*.cl
  ${CMAKE_CURRENT_SOURCE_DIR}/src/media/*.cl
  ${CMAKE_CURRENT_SOURCE_DIR}/src/misc/*.cl
  ${CMAKE_CURRENT_SOURCE_DIR}/src/pipes/*.cl
  ${CMAKE_CURRENT_SOURCE_DIR}/src/relational/*.cl
  ${CMAKE_CURRENT_SOURCE_DIR}/src/subgroup/*.cl
  ${CMAKE_CURRENT_SOURCE_DIR}/src/vldst/*.cl
  ${CMAKE_CURRENT_SOURCE_DIR}/src/workgroup/*.cl
  )

file(GLOB sources ${cl_sources})

include_directories(${CMAKE_CURRENT_SOURCE_DIR}/src/integer)
include_directories(${CMAKE_CURRENT_SOURCE_DIR}/src/workgroup)
include_directories(${CMAKE_CURRENT_SOURCE_DIR}/../ocml/inc)
include_directories(${CMAKE_CURRENT_SOURCE_DIR}/../ockl/inc)
include_directories(${CMAKE_CURRENT_SOURCE_DIR}/../oclc/inc)

opencl_bc_lib(NAME opencl SOURCES ${sources})

=== debian/changelog ===
rocm-llvm (7.0.2+dfsg-1) unstable; urgency=medium

  [ Sakura286 ]
  * Add d/p/use-signed-char-in-comgr-build.patch to fix FTBFS
    on platforms that default to char being unsigned (Closes: #1118511)

  [ Cordell Bloor ]
  * New upstream version 7.0.2+dfsg

 -- Cordell Bloor <cgmb@debian.org>  Fri, 24 Oct 2025 16:47:26 -0600

rocm-llvm (7.0.1+dfsg-1) unstable; urgency=medium

  * Upload to unstable
  * Add riscv64 to build architectures
  * Limit libamd-comgr3 and libamd-comgr-dev to architectures
    with driver support for HSA_AMD

 -- Cordell Bloor <cgmb@debian.org>  Fri, 17 Oct 2025 12:25:52 -0600

rocm-llvm (7.0.1+dfsg-1~exp2) experimental; urgency=medium

  * rocm-device-libs-21: move CMake files to from the global
    library path to /usr/lib/llvm-21/lib/cmake/ to avoid
    conflicts with rocm-device-libs-17 and rocm-device-libs-20
  * hipcc: update manpage
  * Update d/gbp.conf to follow DEP-14
    https://dep-team.pages.debian.net/deps/dep14/

 -- Cordell Bloor <cgmb@debian.org>  Thu, 09 Oct 2025 10:43:52 -0600
